/* <TRANS_COMMAND>
--    

--  
CREATE TABLE LAYERFIELDTYPES (
    ID               NUMBER(10,0) NOT NULL,
    ALIAS            VARCHAR2(255) NOT NULL,
    CREATEDATE       DATE NOT NULL,
    CREATERUSER      VARCHAR2(30) NOT NULL,
    UPDATEDATE       DATE NOT NULL,
    UPDATERUSER      VARCHAR2(30) NOT NULL
)
/

--
ALTER TABLE LAYERFIELDTYPES ADD CONSTRAINT PK_LAYERFIELDTYPES PRIMARY KEY (ID)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON LAYERFIELDTYPES TO budget_users
/

CREATE TABLE LAYERFIELDTYPESDETAIL (
    ID               NUMBER(10,0) NOT NULL,
    ALIAS            VARCHAR(255),
    RECORDINDEX      NUMBER(10,0) NOT NULL,    
    MASK             VARCHAR2(20),
    NOTE             VARCHAR2(2000),
    REGEXP           VARCHAR2(4000),
    FIELDSIZE        NUMBER(10,0),
    MASTERFIELDTYPE  NUMBER(10,0) NOT NULL,
    CONTEXT          VARCHAR2(255),     
    CREATEDATE       DATE NOT NULL,
    CREATERUSER      VARCHAR2(30) NOT NULL,
    UPDATEDATE       DATE NOT NULL,
    UPDATERUSER      VARCHAR2(30) NOT NULL
)
/

GRANT SELECT, INSERT, UPDATE, DELETE ON LAYERFIELDTYPESDETAIL TO budget_users
/

--
ALTER TABLE LAYERFIELDTYPESDETAIL ADD CONSTRAINT PK_LAYERFIELDTYPESDETAIL PRIMARY KEY (ID)
/
                
CREATE INDEX IDX_LRFLDTYPESDET_RECORDINDEX
  ON LAYERFIELDTYPESDETAIL(RECORDINDEX)
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BI
  BEFORE INSERT
  ON LAYERFIELDTYPES
  FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BI_(0)
-- Create 01.07.2013
-- - - - - - - - - - - - -
    if (:new.id is null) then 
     select g_shared.NEXTVAL into :new.id from dual; end if;
-- - - - - - - - - - - - -
-- BI_(500)
-- Create 01.07.2013
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
END;
/

-- Trigger: LAYERFIELDTYPES_BU0 
CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BU
BEFORE UPDATE
ON LAYERFIELDTYPES
FOR EACH ROW
BEGIN
-- - - - - - - - - - - - -
-- BU_(500)
-- Create 01.07.2013
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
END;
/ 

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BD
  BEFORE DELETE
  ON LAYERFIELDTYPES
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BD_0
-- Create 01.07.2013
-- - - - - - - - - - - - -
    DELETE FROM LAYERFIELDTYPESDETAIL WHERE (RecordIndex = :old.ID);
END;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AD
  AFTER DELETE
  ON LAYERFIELDTYPES
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (176, :old.ID, SYSDATE);

end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AI
  AFTER INSERT
  ON LAYERFIELDTYPES
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 176) and (RecordID = :new.ID);
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AU
  AFTER UPDATE
  ON LAYERFIELDTYPES
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (176, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=176) and (RecordId=:new.ID);
  end if;
  
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_BI
  BEFORE INSERT
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 01.07.2013
-- - - - - - - - - - - - -

    if (:new.id is null) then 
     select g_shared.NEXTVAL into :new.id from dual; end if;
    if (:new.mask is null) then 
     :new.mask := '';
    end if; 
    if (:new.regexp is null) then 
     :new.regexp := '';
    end if; 
    if ((:new.fieldsize is null) or (:new.fieldsize < 0))  then 
     :new.fieldsize := 0;
    end if; 

-- - - - - - - - - - - - -
-- BI_500
-- Create 01.07.2013
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_BU
  BEFORE UPDATE
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 01.07.2013
-- - - - - - - - - - - - -

    if (:new.mask is null) then 
     :new.mask := '';
    end if; 
    if (:new.regexp is null) then 
     :new.regexp := '';
    end if; 
    if ((:new.fieldsize is null) or (:new.fieldsize < 0))  then 
     :new.fieldsize := 0;
    end if; 
    
-- - - - - - - - - - - - -
-- BU_500
-- Create 01.07.2013
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AD
  AFTER DELETE
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (177, :old.ID, SYSDATE);
    
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AI
  AFTER INSERT
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 177) and (RecordID = :new.ID);
  
end;
/

CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AU
  AFTER UPDATE
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 01.07.2013
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (177, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=177) and (RecordId=:new.ID);
  end if;
  
end;
/
  
--      
ALTER TABLE LayerFields ADD FIELDTYPEREF NUMBER(10,0)
/

CREATE INDEX IDX_LAYERFIELDS_FIELDTYPEREF ON LAYERFIELDS (FIELDTYPEREF)
/

ALTER TABLE LayerFieldTypesDetail ADD ERRORMESSAGE VARCHAR(255)
/

COMMIT WORK
/
*/
-- <TRANS_IGNORE>
DECLARE
  v_exists INTEGER;
BEGIN
  SELECT COUNT(*)
  INTO v_exists
  FROM USER_TABLES
  WHERE TABLE_NAME = 'LAYERFIELDTYPES';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE '--  
    CREATE TABLE LAYERFIELDTYPES (
        ID               NUMBER(10,0) NOT NULL,
        ALIAS            VARCHAR2(255) NOT NULL,
        CREATEDATE       DATE NOT NULL,
        CREATERUSER      VARCHAR2(30) NOT NULL,
        UPDATEDATE       DATE NOT NULL,
        UPDATERUSER      VARCHAR2(30) NOT NULL
    )';
    EXECUTE IMMEDIATE '--
    ALTER TABLE LAYERFIELDTYPES ADD CONSTRAINT PK_LAYERFIELDTYPES PRIMARY KEY (ID)';
    EXECUTE IMMEDIATE 'GRANT SELECT, INSERT, UPDATE, DELETE ON LAYERFIELDTYPES TO budget_users';
    EXECUTE IMMEDIATE 'CREATE TABLE LAYERFIELDTYPESDETAIL (
        ID               NUMBER(10,0) NOT NULL,
        ALIAS            VARCHAR(255),
        RECORDINDEX      NUMBER(10,0) NOT NULL,    
        MASK             VARCHAR2(20),
        NOTE             VARCHAR2(2000),
        REGEXP           VARCHAR2(4000),
        FIELDSIZE        NUMBER(10,0),
        MASTERFIELDTYPE  NUMBER(10,0) NOT NULL,
        CONTEXT          VARCHAR2(255),   
        CREATEDATE       DATE NOT NULL,
        CREATERUSER      VARCHAR2(30) NOT NULL,
        UPDATEDATE       DATE NOT NULL,
        UPDATERUSER      VARCHAR2(30) NOT NULL
    )';
    EXECUTE IMMEDIATE 'GRANT SELECT, INSERT, UPDATE, DELETE ON LAYERFIELDTYPESDETAIL TO budget_users';
    EXECUTE IMMEDIATE '--
    ALTER TABLE LAYERFIELDTYPESDETAIL ADD CONSTRAINT PK_LAYERFIELDTYPESDETAIL PRIMARY KEY (ID)';                    
    EXECUTE IMMEDIATE 'CREATE INDEX IDX_LRFLDTYPESDET_RECORDINDEX
      ON LAYERFIELDTYPESDETAIL(RECORDINDEX)';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BI
      BEFORE INSERT
      ON LAYERFIELDTYPES
      FOR EACH ROW
    BEGIN
    -- - - - - - - - - - - - -
    -- BI_(0)
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
        if (:new.id is null) then 
         select g_shared.NEXTVAL into :new.id from dual; end if;
    -- - - - - - - - - - - - -
    -- BI_(500)
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
      :NEW.CreateDate := SYSDATE;
      :NEW.UpdateDate := :NEW.CreateDate;
      :NEW.CreaterUser := USER;
      :NEW.UpdaterUser := USER;
    END;';
    EXECUTE IMMEDIATE '-- Trigger: LAYERFIELDTYPES_BU0 
    CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BU
    BEFORE UPDATE
    ON LAYERFIELDTYPES
    FOR EACH ROW
    BEGIN
    -- - - - - - - - - - - - -
    -- BU_(500)
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
        :new.UpdateDate := SYSDATE;
        :new.UpdaterUser := User;
    END;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_BD
      BEFORE DELETE
      ON LAYERFIELDTYPES
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- BD_0
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
        DELETE FROM LAYERFIELDTYPESDETAIL WHERE (RecordIndex = :old.ID);
    END;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AD
      AFTER DELETE
      ON LAYERFIELDTYPES
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AD_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

        insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (176, :old.ID, SYSDATE);

    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AI
      AFTER INSERT
      ON LAYERFIELDTYPES
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AI_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

      delete from DelRecIndexes where (TableID = 176) and (RecordID = :new.ID);
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPES_AU
      AFTER UPDATE
      ON LAYERFIELDTYPES
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AU_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

      if (:new.ID<>:old.ID) then
        insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (176, :old.ID, SYSDATE);
        delete from DelRecIndexes where (TableID=176) and (RecordId=:new.ID);
      end if;
      
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_BI
      BEFORE INSERT
      ON LAYERFIELDTYPESDETAIL
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- BI_(0)
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

        if (:new.id is null) then 
         select g_shared.NEXTVAL into :new.id from dual; end if;
        if (:new.mask is null) then 
         :new.mask := '';
        end if; 
        if (:new.regexp is null) then 
         :new.regexp := '';
        end if; 
        if ((:new.fieldsize is null) or (:new.fieldsize < 0))  then 
         :new.fieldsize := 0;
        end if; 

    -- - - - - - - - - - - - -
    -- BI_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
      :NEW.CreateDate := SYSDATE;
      :NEW.UpdateDate := :NEW.CreateDate;
      :NEW.CreaterUser := USER;
      :NEW.UpdaterUser := USER;
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_BU
      BEFORE UPDATE
      ON LAYERFIELDTYPESDETAIL
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- BU_(0)
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

        if (:new.mask is null) then 
         :new.mask := '';
        end if; 
        if (:new.regexp is null) then 
         :new.regexp := '';
        end if; 
        if ((:new.fieldsize is null) or (:new.fieldsize < 0))  then 
         :new.fieldsize := 0;
        end if; 
        
    -- - - - - - - - - - - - -
    -- BU_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -
        :new.UpdateDate := SYSDATE;
        :new.UpdaterUser := User;
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AD
      AFTER DELETE
      ON LAYERFIELDTYPESDETAIL
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AD_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

        insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (177, :old.ID, SYSDATE);
        
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AI
      AFTER INSERT
      ON LAYERFIELDTYPESDETAIL
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AI_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

      delete from DelRecIndexes where (TableID = 177) and (RecordID = :new.ID);
      
    end;';
    EXECUTE IMMEDIATE 'CREATE OR REPLACE TRIGGER TR_LAYERFIELDTYPESDETAIL_AU
      AFTER UPDATE
      ON LAYERFIELDTYPESDETAIL
      FOR EACH ROW
    begin

    -- - - - - - - - - - - - -
    -- AU_500
    -- Create 01.07.2013
    -- - - - - - - - - - - - -

      if (:new.ID<>:old.ID) then
        insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (177, :old.ID, SYSDATE);
        delete from DelRecIndexes where (TableID=177) and (RecordId=:new.ID);
      end if;
      
    end;';      
    EXECUTE IMMEDIATE '--      
    ALTER TABLE LayerFields ADD FIELDTYPEREF NUMBER(10,0)';
    EXECUTE IMMEDIATE 'CREATE INDEX IDX_LAYERFIELDS_FIELDTYPEREF ON LAYERFIELDS (FIELDTYPEREF)';
    EXECUTE IMMEDIATE 'COMMIT WORK';
  END IF;



  SELECT COUNT(*)
  INTO v_exists
  FROM USER_TAB_COLUMNS
  WHERE TABLE_NAME = 'LAYERFIELDTYPESDETAIL' AND COLUMN_NAME = 'ERRORMESSAGE';
  IF (v_exists = 0) THEN
    EXECUTE IMMEDIATE 'ALTER TABLE LayerFieldTypesDetail ADD ERRORMESSAGE VARCHAR(255)';
    EXECUTE IMMEDIATE 'COMMIT WORK'; 
  END IF;
END;
/
